---
title: box-lines
slug: Web/CSS/box-lines
tags:
  - CSS
  - CSS Property
  - Non-standard
  - Reference
  - 'recipe:css-property'
---
<div>{{CSSRef}}{{Non-standard_header}}</div>

<div class="notecard warning">
<p>This is a property of the original CSS Flexible Box Layout Module draft, and has been replaced by a newer standard. See <a href="/en-US/docs/Web/CSS/CSS_Flexible_Box_Layout/Using_CSS_flexible_boxes">flexbox</a> for information about the current standard.</p>
</div>

<p>The <strong><code>box-lines</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> property determines whether the box may have a single or multiple lines (rows for horizontally oriented boxes, columns for vertically oriented boxes).</p>

<pre class="brush: css no-line-numbers notranslate">/* Keyword values */
box-lines: single;
box-lines: multiple;

/* Global values */
box-lines: inherit;
box-lines: initial;
box-lines: unset;
</pre>

<p>By default a horizontal box will lay out its children in a single row, and a vertical box will lay out its children in a single column. This behavior can be changed using the <code>box-lines</code> property. The default value is <code>single</code>, which means that all elements will be placed in a single row or column, and any elements that don't fit will be considered overflow.</p>

<p>If a value of <code>multiple</code> is specified, however, then the box is allowed to expand to multiple lines (that is, multiple rows or columns) in order to accommodate all of its children. The box must attempt to fit its children on as few lines as possible by shrinking all elements down to their minimum widths or heights if necessary.</p>

<p>If the children in a horizontal box still do not fit on a line after being reduced to their minimum widths, then children are moved one by one onto a new line, until the elements remaining on the previous line fit. This process can repeat to an arbitrary number of lines. If a line contains only a single element that doesn't fit, then the element should stay on that line and overflow out of the box. The later lines are placed below the earlier lines in normal direction boxes and above in reverse direction boxes. The height of a line is the height of the largest child in that line. No additional space appears between the lines apart from the margins on the largest elements in each line. For calculating the height of a line, margins with a computed value of auto should be treated as having a value of 0.</p>

<p>A similar process occurs for children in a vertical box. Later lines in normal direction boxes are placed to the right of earlier lines and to the left in reverse direction boxes.</p>

<p>Once the number of lines has been determined, elements with a computed value for {{CSSxRef("box-flex")}} other than <code>0</code> stretch as necessary in an attempt to fill the remaining space on the lines. Each line computes flexes independently, so only elements on that line are considered when evaluating {{CSSxRef("box-flex")}} and {{CSSxRef("box-flex-groups")}}. The packing of elements in a line, as specified by the {{CSSxRef("box-pack")}} property, is also computed independently for each line.</p>

<h2 id="Syntax">Syntax</h2>

<p>The <code>box-lines</code> property is specified as one of the keyword values listed below.</p>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>single</code></dt>
 <dd>Box elements lay out in a single row or column.</dd>
 <dt><code>multiple</code></dt>
 <dd>Box elements layout in multiple rows or columns.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{CSSInfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{CSSSyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Simple_usage_example">Simple usage example</h3>

<p>In the original version of the spec, <code>box-lines</code> allowed you to specify that you wanted your flex container's children to wrap onto multiple lines. This was only supported in WebKit-based browsers, with a prefix.</p>

<pre class="brush: css notranslate">div {
  display: box;
  box-orient: horizontal;
  box-lines: multiple;
}</pre>

<p>The modern flexbox equivalent is <code><a href="/en-US/docs/Web/CSS/flex-wrap">flex-wrap</a></code>.</p>

<h2 id="Specifications">Specifications</h2>

<p>Not part of any standard.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("css.properties.box-lines")}}</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{CSSxRef("box-flex")}}</li>
 <li>{{CSSxRef("box-flex-group")}}</li>
 <li>{{CSSxRef("box-pack")}}</li>
</ul>
